> For the complete documentation index, see [llms.txt](https://docs.coresignal.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.coresignal.com/legacy-data/clean-employee-api/endpoints/bulk-collect/post-requests.md).

# POST Requests: Clean Employee API

{% columns %}
{% column width="16.666666666666664%" %}
Data type:

URLs:
{% endcolumn %}

{% column %}
Clean Employee

<https://api.coresignal.com/cdapi/v2/data\\_requests/employee\\_clean/es\\_dsl\\>
<https://api.coresignal.com/cdapi/v2/data\\_requests/employee\\_clean/id\\_file\\>
<https://api.coresignal.com/cdapi/v2/data\\_requests/employee\\_clean/shorthand\\_names\\>
<https://api.coresignal.com/cdapi/v2/data\\_requests/employee\\_clean/urls>
{% endcolumn %}
{% endcolumns %}

***

## Overview

Bulk Collect features three POST endpoints, making collecting employee data records in bulk easier.

{% hint style="danger" %}
Before you proceed with your Bulk Collect requests, test them in the Clean Employee API first to avoid any unexpected costs.
{% endhint %}

Find step-by-step guides for making Bulk Collect POST requests in the following topic:

<table data-view="cards"><thead><tr><th></th><th data-hidden data-card-target data-type="content-ref"></th></tr></thead><tbody><tr><td>Bulk Collect POST requests guides</td><td><a href="/api-introduction/requests/bulk-collect/post-requests.md">POST Requests</a></td></tr></tbody></table>

## Elasticsearch DSL requests

Use the endpoint `/v2/data_requests/employee_clean/es_dsl` to request employee data in bulk using our Elasticsearch DSL schema.

<table data-view="cards"><thead><tr><th></th><th data-hidden data-card-target data-type="content-ref"></th></tr></thead><tbody><tr><td>Clean Employee API Elasticsearch DSL schema</td><td><a href="/legacy-data/clean-employee-api/endpoints/elasticsearch-dsl.md#elasticsearch-schema">Elasticsearch DSL</a></td></tr></tbody></table>

### Endpoint usage example

{% code title="Example request" %}

```json
curl -X 'POST' \
'https://api.coresignal.com/cdapi/v2/data_requests/employee_clean/es_dsl' \
  -H 'accept: application/json' \
  -H 'apikey: {API Key}' \
  -H 'Content-Type: application/json' \
  -d '{
   "webhook_url": "{optional_webhook_url}",
   "limit": {optional_integer},
   "es_dsl_query": {
      "query": {
         "bool": {
            "should": [
               {
                  "query_string": {
                     "query": "Python",
                     "default_field": "description",
                     "default_operator": "and"
                  }
               },
               {
                  "query_string": {
                     "query": "Python",
                     "default_field": "job_title",
                     "default_operator": "and"
                  }
               },
               {
                  "nested": {
                     "path": "experience",
                     "query": {
                        "bool": {
                           "should": [
                              {
                                 "query_string": {
                                    "query": "Python",
                                    "default_field": "experience.description",
                                    "default_operator": "and"
                                 }
                              },
                              {
                                 "query_string": {
                                    "query": "Python",
                                    "default_field": "experience.title",
                                    "default_operator": "and"
                                 }
                              }
                           ]
                        }
                     }
                  }
               }
            ]
         }
      }
   }
}'
```

{% endcode %}

Retrieve the request ID from the response body

{% code title="Request ID" %}

```json
{
  "request_id": "433869ec-0a98-4dcd-9b13-db4df58260f5"
}
```

{% endcode %}

* `Location` response header provides a URL where the results can be retrieved.

> Location: /v2/data\_requests/e000b0ec-0f00-0b00-0a0a-0b00fa0000d0/files

***

## ID File requests&#x20;

Use the endpoint `/v2/data_requests/employee_clean/id_file` to submit a list of IDs in a .csv or .txt file format to request employee data in bulk.  The following topic explains how to make ID File request:

<table data-view="cards"><thead><tr><th></th><th data-hidden data-card-target data-type="content-ref"></th></tr></thead><tbody><tr><td>ID File request guide</td><td><a href="/api-introduction/requests/bulk-collect/post-requests.md#id-file-requests">POST Requests</a></td></tr></tbody></table>

### Endpoint usage example

{% code title="cURL request" %}

```json
curl -X 'POST' \
  'https://api.coresignal.com/cdapi/v2/data_requests/employee_clean/id_file' \
  -H 'accept: application/json' \
  -H 'apikey: {API Key}' \
  -H 'Content-Type: multipart/form-data' \
  -F 'ids_file=@id_list_example.csv;type=text/csv' \
  -F 'webhook_url={optional_webhook_url}'
```

{% endcode %}

Retrieve the `request_id` from the response body:

{% code title="Request ID" %}

```json
{
  "request_id": "433869ec-0a98-4dcd-9b13-db4df58260f5"
}
```

{% endcode %}

* `Location` response header provides a URL where the results can be retrieved.

> Location: /v2/data\_requests/e000b0ec-0f00-0b00-0a0a-0b00fa0000d0/files

***

## Shorthand names and URLs requests

You can send up to 10,000 `shorthand_names` or `URLs` per request. Requirements for `shorthand_names` are listed below:

<table data-view="cards"><thead><tr><th></th><th data-hidden data-card-target data-type="content-ref"></th></tr></thead><tbody><tr><td>Shorthand names requirements</td><td><a href="/api-introduction/requests/bulk-collect/post-requests.md#shorthand-names-and-urls-requests">POST Requests</a></td></tr></tbody></table>

### Endpoint usage

{% tabs %}
{% tab title="Example request for shorthand\_names" %}
{% code title="Example request for shorthand\_names" %}

```json
curl -X 'POST' \
  'https://api.coresignal.com/cdapi/v2/data_requests/employee_clean/shorthand_names' \
  -H 'accept: application/json' \
  -H 'apikey: {API Key}' \
  -H 'Content-Type: application/json' \
  -d '{
   "webhook_url": "{optional_webhook_url}",
   "shorthand_names": [
      "john-doe",
      "jane-doe",
      "john-smith"
      ]
   }'
```

{% endcode %}
{% endtab %}

{% tab title="Example request for urls" %}
{% code title="Example request for urls" %}

```json
curl -X 'POST' \
  'https://api.coresignal.com/cdapi/v2/data_requests/employee_clean/urls' \
  -H 'accept: application/json' \
  -H 'apikey: {API Key}' \
  -H 'Content-Type: application/json' \
  -d '{
   "webhook_url": "{optional_webhook_url}",
   "urls": [
      "https://www.professional-network.com/in/john-doe",
      "https://www.professional-network.com/in/jane-doe",
      "https://www.professional-network.com/in/john-smith"
      ]
   }'
```

{% endcode %}
{% endtab %}
{% endtabs %}

Retrieve the request ID from the response body:

{% code title="Request ID" %}

```json
{
  "request_id": "433869ec-0a98-4dcd-9b13-db4df58260f5"
}
```

{% endcode %}

* `Location` response header provides a URL where the results can be retrieved.

> Location: /v2/data\_requests/e000b0ec-0f00-0b00-0a0a-0b00fa0000d0/files

## Following steps

<table data-view="cards"><thead><tr><th></th><th data-hidden data-card-target data-type="content-ref"></th></tr></thead><tbody><tr><td>Make GET requests to download the data</td><td><a href="/api-introduction/requests/bulk-collect/get-requests.md">GET Requests</a></td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.coresignal.com/legacy-data/clean-employee-api/endpoints/bulk-collect/post-requests.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
